/*
 * Copyright (c) 2006 Israfil Consulting Services Corporation
 * Copyright (c) 2006 Christian Edward Gruber
 * All Rights Reserved
 * 
 * This software is licensed under the Berkeley Standard Distribution license,
 * (BSD license), as defined below:
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this 
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 *    this list of conditions and the following disclaimer in the documentation 
 *    and/or other materials provided with the distribution.
 * 3. Neither the name of Israfil Consulting Services nor the names of its contributors 
 *    may be used to endorse or promote products derived from this software without 
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 * 
 * $Id: GenericCache.java 499 2007-05-15 19:16:17Z christianedwardgruber $
 */
package net.israfil.foundation.caching;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.locks.ReadWriteLock;
import java.util.concurrent.locks.ReentrantReadWriteLock;


/**
 * A non-thread-safe cache object
 * 
 * @author <a href="mailto:cgruber@israfil.net">Christian Edward Gruber</a>
 */
public class GenericCache<K,T> implements Cache <K,T>{
	
	private final ReadWriteLock lock = new ReentrantReadWriteLock();
	
	private String id;
	
	private ObjectFactory<T> factory;
	
	private Map<K[],T> _caches = new HashMap<K[],T>();
		
	public GenericCache(String id) {
		this.id = id;
	}
	
	public String getId() {
		return id;
	}

	/**
	 * Retrieves an object from a path in the cache
	 * @param An array of path items identifying the path through the map keys.
	 */
	public T get(K ... path) {
					
		// Get the item from the map
		
		return null;
	}

	public ObjectFactory<T> getFactory() {
		// TODO Auto-generated method stub
		return null;
	}

	public void purge(K... path) {
		// TODO Auto-generated method stub
		
	}

	public void setFactory(ObjectFactory<T> factory) {
		try {
			lock.writeLock().lock();
			this.factory = factory;
			
		} finally {
			lock.writeLock().unlock();
		}
	}
	
	
}
